	include	"flib.h"
	include	"tios.h"
	include	mactext.h
	xdef	_main
	xdef	_comment
_main:
;**********************************Programme***********************************
;By Laurent PONCEY
;lponcey@club-internet.fr
;******************************************************************************
	move.w	#$700,d0		;\ disable interrupts, and put
	trap	#1			;/ the old int mask in D0
	move.w	d0,-(sp)		; push old int mask onto stack

	jsr	flib::clr_scr

	SetFont         #2
        WriteStr        #40,#10,#1,titre
	SetFont		#1
	WriteStr	#30,#40,#1,auteur
	SetFont		#0
	WriteStr	#60,#60,#1,addr
	WriteStr	#150,#123,#1,aide

	lea	freq(PC),a0
	lea	morc1(PC),a1
	lea	morc2(PC),a2

	bset	#6,($60000C)
	bclr	#0,($60000E)
	bclr	#1,($60000E)

	move.w	#1,duree1
	move.w	#1,duree2

boucle:
	sub.w	#1,duree1
	cmp.w	#0,duree1
	bne	cont_1
;charge 1
;touche [Esc] enfonce ?
	move.w	#8,d0	;[Esc]
	bsr	masque
	btst.b	#6,d0
	beq	fin

	cmp.w	#255,(a1)
	beq	fin			;255=end
	clr.l	d0
	move.w	(a1)+,d0		;frquence
	move.w	(a1)+,d2		;longueur
	move.b	#1,d1
	bsr	decode
	move.w	tps1,d7			;dure crneau 1
;en opposition de polarit avec 2
	btst	#1,($60000E)
	bne	plus1
	bclr	#0,($60000E)
	bra	cont_1
plus1:
	bset	#0,($60000E)

cont_1:
	sub.w	#1,duree2
	cmp.w	#0,duree2
	bne	cont_2
;charge 2
	cmp.w	#255,(a2)
	beq	fin			;255=fin
	clr.l	d0
	move.w	(a2)+,d0		;freq
	move.w	(a2)+,d2		;length
	move.b	#2,d1
	bsr	decode
	move.w	tps2,d6			;dure crneau 2
;en opposition de polarit avec 1
	btst	#0,($60000E)
	bne	plus2
	bclr	#1,($60000E)
	bra	cont_2
plus2:
	bset	#1,($60000E)

cont_2:
	move.w	unittps,d4		;nbre rptitions

;cas d'une pause
	cmp.w	tps1,d4
	bhi	paspause1
	move.w	tps1,d7
paspause1:
	cmp.w	tps2,d4
	bhi	paspause2
	move.w	tps2,d6
paspause2:

;joue le son pendant une dure lmentaire
bcle_son:
	dbf.w	d7,son_1
	move.w	tps1,d7
	bchg	#0,($60000E)
son_1:
	dbf.w	d6,son_2
	move.w	tps2,d6
	bchg	#1,($60000E)
son_2:
	dbf	d4,bcle_son
	bra	boucle

fin:
	bclr	#0,($60000E)
	bclr	#1,($60000E)
	move.b	#$8D,($60000C)

	move.w	(sp)+,d0		;\ restore old
	trap	#1			;/  int mask
	rts

;******************************************************************************
;Dcode une valeur de note
;------------------------------------------------------------------------------
;d0=valeur code (1er chiffre hexa=octave, 2me=note), d1=voie (1 ou 2),
;d2=dure
; =>d0=frq
;******************************************************************************
decode:
	move.l	d1,-(a7)
	cmp.w	#0,d0
	beq	pause			;si c'est une pause
	move.l	d0,d1			;en hexa, 1er nombre=octave (1-4)
	ror.l	#4,d1			;         2nd       =note (1-c)
	sub.w	#1,d1
	mulu.w	#12,d1	
	and.w	#$0f,d0
	sub.w	#1,d0
	add.w	d1,d0
	rol.l	#1,d0
	move.l	a0,a3
	add.l	d0,a3	
	clr.l	d0
	move.w	(a3),d0
	bra	stoc
pause:
	move.w	unittps,d0
	add.w	#1,d0
stoc:
	move.l	(a7)+,d1
	cmp.b	#1,d1
	bne	stoc2
	move.w	d0,tps1
	move.w	d2,duree1
	rts
stoc2:
	move.w	d0,tps2
	move.w	d2,duree2
	rts

;********************************
;masque une ligne clavier
;--------------------------------
;d0=ligne -> d0=rponse
;********************************
masque:
	movem.l		d1,-(a7)
	move.w		#$FFFE,d1
	rol.w		d0,d1
	clr.w		d0
	move.w		d1,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	move.b		($60001B),d0
	movem.l		(a7)+,d1
	rts

;***********************************Donnes************************************

_comment	dc.b	"Music : Bach 'Invention 4'",0

titre		dc.b	"Bach 'Invention 4'",0
auteur		dc.b	"A program by Laurent PONCEY",0
addr		dc.b	"<lponcey@club-internet.fr>",0
aide		dc.b	"Press [Esc] to quit",0

freq:	dc.w	$3ea,$3b6,$380,$34e,$31e,$2f0,$2f0,$2c6,$29e,$277,$253,$232,$212
	dc.w	$1f5,$1db,$1c0,$1a7,$18f,$178,$163,$14f,$13c,$12b,$11a,$10a
	dc.w	$fb,$ed,$df,$d3,$c6,$bb,$b0,$a6,$9d,$94,$8b,$83
	dc.w	$7c,$75,$6e,$67,$61,$5c,$56,$51,$4c,$48,$44,$40

tps1	dc.w	$0			;dure d'une phase du crneau
tps2	dc.w	$0
duree1	dc.w	$0			;dure  jouer restante
duree2	dc.w	$0

unittps	dc.w	$5000			;dure d'une dure lmentaire

morc1	dc.w	$23,04,$25,04,$26,04,$28,04,$2a,04,$2b,04,$22,04,$2b,04,$2a,04,$28,04,$26,04,$25,04
	dc.w	$26,08,$2a,08,$33,08,$28,08,$32,08,$35,08
	dc.w	$33,04,$35,04,$36,04,$38,04,$3a,04,$3b,04,$32,04,$3b,04,$3a,04,$38,04,$36,04,$35,04
	dc.w	$36,04,$33,04,$35,04,$36,04,$38,04,$3a,04,$2b,04,$3a,04,$38,04,$36,04,$35,04,$33,04
	dc.w	$35,04,$31,04,$33,04,$35,04,$36,04,$38,04,$2a,04,$38,04,$36,04,$35,04,$33,04,$31,04
	dc.w	$33,04,$35,04,$36,04,$33,04,$35,04,$36,04,$28,08,$00,16
	dc.w	$31,04,$33,04,$35,04,$31,04,$33,04,$35,04,$36,08,$00,08,$3b,16
	dc.w	$3a,08,$38,08,$41,04,$3b,04,$3a,04,$38,04,$36,04,$35,04
	dc.w	$36,04,$38,04,$38,08,$00,04,$36,03,$00,01,$36,08,$41,07,$00,01,$41,07,$00,01
	dc.w	$41,76
	dc.w	$3b,04,$3a,04,$38,04,$36,04,$35,04
	dc.w	$41,24
	dc.w	255

morc2	dc.w	$00,48
	dc.w	$23,04,$25,04,$26,04,$28,04,$2a,04,$2b,04,$22,04,$2b,04,$2a,04,$28,04,$26,04,$25,04
	dc.w	$26,08,$2a,08,$33,08,$25,08,$28,08,$32,08
	dc.w	$23,08,$33,08,$26,08,$28,08,$2a,08,$2b,08
	dc.w	$21,08,$31,08,$25,08,$26,08,$28,08,$2a,08
	dc.w	$2b,04,$28,04,$2a,04,$2b,04,$31,04,$33,04,$25,04,$33,04,$31,04,$2b,04,$2a,04,$28,04
	dc.w	$2a,04,$26,04,$28,04,$2a,04,$2b,04,$31,04,$23,04,$31,04,$2b,04,$2a,04,$28,04,$26,04
	dc.w	$25,04,$31,04,$33,04,$35,04,$36,04,$38,04,$2a,04,$38,04,$36,04,$35,04,$33,04,$31,04
	dc.w	$33,04,$2b,04,$31,08,$21,08,$26,04,$28,04,$2a,04,$2b,04,$31,04,$33,04
	dc.w	$25,04,$33,04,$31,04,$2b,04,$2a,04,$28,04,$2a,04,$2b,04,$31,04,$33,04,$35,04,$36,04
	dc.w	$28,04,$36,04,$35,04,$33,04,$31,04,$2b,04,$2a,04,$2b,04,$31,04,$2a,04,$2b,04,$31,04
	dc.w	$26,24
	dc.w	255
	end
